Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices

Namespace VSCom.J1939Api


    Class Test

        Private Shared Function AddressCallback() As Byte
            Return 252
        End Function

        Public Shared Function ByteArrayToString(ByVal ba() As Byte) As String
            Dim hex As String = BitConverter.ToString(ba)
            Return hex.Replace("-", "")
        End Function

        Private Shared Sub PrintFrame(ByVal msg As VSCAN_J1939.VSCAN_J1939_MSG)
            Console.WriteLine(String.Format("S:{0},D:{1},P:{2},PGN:{3},L:{4},{5}", msg.Src, msg.Dst, msg.Priority, msg.PGN, msg.Size, Test.ByteArrayToString(msg.Data)))
        End Sub

        Public Shared Sub Main(ByVal args() As String)
            Dim CanDevice As VSCAN = New VSCAN
            Dim j1939 As VSCAN_J1939 = New VSCAN_J1939
            Dim addrCallback As VSCAN_J1939.VSCAN_J1939_ADDR_CALLBACK = New VSCAN_J1939.VSCAN_J1939_ADDR_CALLBACK(AddressOf AddressCallback)
            Try
                ' set debugging options
                CanDevice.SetDebug(VSCAN.VSCAN_DEBUG_NONE)
                CanDevice.SetDebugMode(VSCAN.VSCAN_DEBUG_MODE_FILE)
                CanDevice.Open("COM51", VSCAN.VSCAN_MODE_NORMAL)
                CanDevice.SetSpeed(VSCAN.VSCAN_SPEED_250K)
                Dim codeMask As VSCAN_CODE_MASK = New VSCAN_CODE_MASK
                codeMask.Code = 0
                codeMask.Mask = &HFFFFFFFFUI
                CanDevice.SetACCCodeMask(codeMask)
                Dim name As VSCAN_J1939.VSCAN_J1939_NAME = New VSCAN_J1939.VSCAN_J1939_NAME
                name.ArbAddrCapable = 0
                name.IndustryGroup = 1
                name.VehicleSys = 1
                name.Func = 255
                name.ManCode = 102
                j1939.Init(CanDevice.handle, name, addrCallback)
                Dim msg() As VSCAN_J1939.VSCAN_J1939_MSG = New VSCAN_J1939.VSCAN_J1939_MSG((1) - 1) {}
                Dim read As UInt32 = 0

                Do While True
                    If (j1939.Read_BufferCount > 0) Then
                        j1939.Read(msg, 1, read)
                        Test.PrintFrame(msg(0))
                    End If


                Loop

                j1939.Free()
                CanDevice.Close()
            Catch ex As Exception
                Console.WriteLine(("Error: " + ex.Message))
            End Try

        End Sub
    End Class
End Namespace
